# Description

This IO plugin lets you to store your progress in a single file (.h5 extension). It stores not only the layer's data but also its metadata, meaning that in some way, this IO can be seen as a project file generator.

The current supported layer types are: images, labels and dots.

This plugin was developed to create a connection between napari (for labeling) and YAPiC (a deep learning segmentation tool).

# Who is this for?

This plugin is meant to be used for any napari user wanting to store their progress in a single file and for those which use napari as a labeling tool.

It supports any data dimensionality and it was designed to improve the memory efficiency when storing label layers.

Additionally, YAPiC supports the files generated by this IO to perform image segmentation.

# Quick start

## Saving .h5 files

With `napari-hdf5-labels-io installed`, use napari as alway. once you are done, click in File, click in Save Selected Layer(s)... (Ctrl+S) or Save All Layers... (Ctrl+Shift+S) and write the output file name as `filename.h5`. Including the ".h5" extension at the end of the name will automatically activate the plugin.

## Opening .h5 files

To open a .h5 file written with this plugin, you can open this file as any other (either by the Open File option in the File menu or dragging it to the main window).